var gulp         = require('gulp');
var autoprefixer = require('gulp-autoprefixer');
var del          = require('del');
var runSequence  = require('run-sequence');
var cache        = require('gulp-cache');
var nano         = require('gulp-cssnano');
var minify       = require('gulp-minify');


// General tasks

gulp.task('build',  function( callback ) {
  runSequence('clean', ['styles', 'scripts'],
    callback
  )
});

gulp.task('clean', function( callback ) {
  del( ['dist'] );
  return cache.clearAll( callback );
});


// (S)CSS tasks

gulp.task('styles', function( callback ) {
  runSequence('autoprefix', 'minifyCSS',
    callback
  )
});

gulp.task('autoprefix', function() {
  return gulp.src('app/css/jquery-browserWrap.css')
    .pipe(autoprefixer({
      browsers: ['last 4 versions'],
      cascade: false
    }))
    .pipe(gulp.dest('dist'));
});

gulp.task('minifyCSS', function(){
  return gulp.src('dist/jquery-browserWrap.css')
    .pipe(nano())
    .pipe(gulp.dest('dist'));
});


// Script tasks

gulp.task('scripts', function( callback ) {
  runSequence('minifyJS',
    callback
  )
});

gulp.task('minifyJS', function( callback ) {
  return gulp.src('app/js/jquery.browserWrap.js')
    .pipe(minify({
      mangle: false,
    }))
    .pipe(gulp.dest('dist'));
});
